--- UNDO ADDED 12-24-08

macroScript Piston_Builder category:"Piston Builder" tooltip:"Piston Builder"
(


-- > LEFT PISTON WILL BE OUTER PISTON / LEFT PISTON HEIGHT WILL BE NEGATIVE   ,   > RIGHT PISTON WILL BE INNER PISTON

OuterRadius =0

OuterPistonHeight=0

InnerRadius=0

InnerPistonHeight=0

DistanceBetweenObjects =0

LeftObjectPosition =0

RightObjectPosition =0

DistanceLength = 0


OuterPiston = 0  -- LEFT PISTON
InnerPiston = 0  -- RIGHT PISTON

ParentSize = 0

OuterParent = 0
InnerParent = 0

InParentMainRad = 0
InParentCrsRad = 0

OutParentMainRad = 0
OutParentCrsRad = 0

UserParentRt = 0

UserParentLeft = 0

FilletOuter = 0
FilletInner = 0

CutPoint = 0     -- NEW VARIABLE

LeftChosen = 0
RightChosen = 0

---------------------------------=============================+++++++++++++++++++++++++++++++++)))))))))))))))))))))))))))))))*&^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

rollout PistonBuilder "Piston Builder" width:200 Height:180  --158
(

----   DEFINE  BUTTONS
pickbutton ChooseLftObj "Left Object"
pickbutton ChooseRtObj "Right Object"

spinner OuterPistonRadius "Outer Piston Radius" range:[0,100000,15]
spinner InnerPistonRadius "Inner Piston Radius" range:[0,100000,8]

button CutInnerDefault "Default" offset:[-18,0 ]  across:2  
spinner CutInnerPistonAt "Cut Inner At" range:[-100,100,1]  offset:[-15,0 ]


button BuildPiston "Build Piston" tooltip: "Note:cut of 1 = total distance" height:40

 


---------->>>>>>>>>>>>>>>>>> LEFT PICK BUTTON            LLLLLLLLLLLLLLLLL
 

--If the user picked an object, then

on CutInnerDefault pressed do ( CutInnerPistonAt.value = 1 )


on ChooseLftObj picked obj do

( 

--see if the user did not cancel the picking... 

 if obj != undefined do

 (

--and display the name of the object on the button: 

ChooseLftObj.text = obj.name

LeftObjectPosition = obj.position

UserParentLeft = obj

LeftChosen = 1    ----   NEW   VARIABLE   ----- @@@ 

 )

)-- END PICKBUTTON




---------->>>>>>>>>>>>>>>>>> RIGHT PICK BUTTON       RRRRRRRRRRRRRR

on ChooseRtObj picked obj do

( 

--see if the user did not cancel the picking... 

 if obj != undefined do

 (

--and display the name of the object on the button: 

ChooseRtObj.text = obj.name

RightObjectPosition = obj.position

UserParentRt = obj

RightChosen = 1    ----   NEW   VARIABLE   ----- @@@  

 )

) --- END PICKBUTTON



----   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$    BUILD THE PISTON    $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
----   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$    BUILD THE PISTON    $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$



on BuildPiston pressed do
(
undo "Build Piston" on (

if RightChosen == 1  and  LeftChosen == 1 then (     -- NEW ERROR CHECK --

OuterRadius = OuterPistonRadius.value
InnerRadius= InnerPistonRadius.value

CutPoint = CutInnerPistonAt.value  -- $$ NEW VARIABLE  $$


DistanceBetweenObjects = RightObjectPosition - LeftObjectPosition --  find xyz position distance 
DistanceLength = Length(DistanceBetweenObjects)   -- convert xyz postion difference to a length value  using the length function 

OuterPistonHeight= -(DistanceLength / 2)

InnerPistonHeight = ( DistanceLength * CutPoint )          --  DIVIDE AT SPINNER VALUE HERE $$$$$$$$$$$$$$$$$$$$$$<<<<<<<<<<<<   0  >>>>>>>>>>>>>>>>>
											--  DIVIDE AT SPINNER VALUE HERE $$$$$$$$$$$$$$$$$$$$$$<<<<<<<<<<<<   0  >>>>>>>>>>>>>>>>>
											--  DIVIDE AT SPINNER VALUE HERE $$$$$$$$$$$$$$$$$$$$$$<<<<<<<<<<<<   0  >>>>>>>>>>>>>>>>>



---  BUILD OUTER PISTON  LFT  AND PARENT

OutParentMainRad = OuterRadius * 1.5
OutParentCrsRad = OutParentMainRad / 6
FilletOuter = OuterRadius * .2


-- TRY CHAMFER CYL OUTER
ChamferCyl radius:OuterRadius height:OuterPistonHeight Fillet:FilletOuter Height_Segments:1 Fillet_Segments:1 sides:12 Cap_Segments:1 Smooth_On:1 Slice_On:0 Slice_From:0 Slice_To:0 mapcoords:1 pos:[0,0,0] isSelected:on

OuterPiston= $
$.position = LeftObjectPosition
$.wirecolor = blue

Torus smooth:2 segs:3 sides:3 radius1:OutParentMainRad radius2:OutParentCrsRad mapcoords:on transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [-286.426,3.41834e-006,-78.2026]) isSelected:on
$.wirecolor = yellow
$.position = LeftObjectPosition
OuterParent = $
$.parent = OuterPiston




--- BUILD INNER PISTON  RT    AND PARENT

InParentMainRad = OuterRadius * .9
InParentCrsRad = InParentMainRad / 6
FilletInner = InParentMainRad * .2


-- TRY CHAMFER CYL INNER
ChamferCyl radius:InnerRadius height:InnerPistonHeight Fillet:FilletInner Height_Segments:1 Fillet_Segments:1 sides:12 Cap_Segments:1 Smooth_On:1 Slice_On:0 Slice_From:0 Slice_To:0 mapcoords:1 pos:[0,0,0] isSelected:on

InnerPiston= $
$.position = RightObjectPosition
$.wirecolor = green

Torus smooth:2 segs:3 sides:3 radius1:InParentMainRad radius2:InParentCrsRad mapcoords:on transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [-286.426,3.41834e-006,-78.2026]) isSelected:on
$.wirecolor = yellow
$.position = RightObjectPosition
InnerParent = $
$.parent = InnerPiston


--- SET UP LOOK AT CONSTRAINTS
  
--OUTER PISTON

select OuterPiston

$.rotation.controller = LookAt_Constraint ()
$.rotation.controller.constraints.appendTarget InnerParent 50.0

$.rotation.controller.upnode_world = off

$.rotation.controller.pickUpNode = InnerParent

$.rotation.controller.target_axis = 2
$.rotation.controller.upnode_axis = 1
$.rotation.controller.StoUP_axis = 1

$.rotation.controller.target_axisFlip = on

select OuterParent
max unlink

OuterPiston.parent = OuterParent

-- INNER PISTON




select InnerPiston

$.rotation.controller = LookAt_Constraint ()
$.rotation.controller.constraints.appendTarget OuterParent 50.0

$.rotation.controller.upnode_world = off

$.rotation.controller.pickUpNode = OuterParent

$.rotation.controller.target_axis = 2
$.rotation.controller.upnode_axis = 1
$.rotation.controller.StoUP_axis = 1



select InnerParent
max unlink

InnerPiston.parent = InnerParent

InnerParent.parent = UserParentRt 
OuterParent.parent =  UserParentLeft 



) -- END IF ERROR CHECK

else 
(
messagebox "Select 2 Objects"
)    ---  NEW ERROR MESSAGE BOX

) -- END UNDO

) ----- END BUILD PISTON BUTTON





) ----end rollout @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


CreateDialog PistonBuilder


) --- END  MACROSCRIPT









